<template>
    <div class="row pay-sum-order">
        <div class="column">
            <div :class="{'white-block': !card}">

              <div v-if="!card" class="section__header section__header-with-back">
                <div class="section__header-back" v-on:click="$emit('hideForm')">
                  <SVGIcon xlink="next-arrow-20" viewBox="0 0 20 20" :rotate="180"/>
                </div>
                <h3 class="section__header-title">{{text}}</h3>
              </div>

                <div :class="{padding: !card}">
                    <div class="row">
                        <div class="columns six pay-sum">
                            <label for="pay-sum">Сумма оплаты</label>
                            <input v-validate="'required'"
                                   type="number"
                                   name="pay-sum"
                                   class="methods-pay-sum"
                                   id="pay-sum"
                                   placeholder="Введите сумму для оплаты займа"
                                   v-model="sumToPay"

                                   @keyup.enter="$parent.click()"
                                   :disabled="$pay.paymentType === 'prolongation_deposit' || $pay.paymentType === 'credit_rating'"
                            >
                            <span class="ruble">₽</span>
                            <!--@blur="roundToTen"-->
                            <!-- <div class="bonus_wrapper" v-if="$pay.bonusBalance && $interface.cashback && $pay.paymentType === 'PDL'">
                                <transition name="fade" :duration="300">
                                    <div class="bonus_rouble" v-if="!showBonusBill"
                                         @click="showBonusBill = !showBonusBill">
                                        {{$interface.viewport === 'mobile' ? 'Использовать бонусные рубли' :
                                        'Использовать для оплаты бонусные рубли'}}
                                    </div>
                                    <div v-else class="calculate">
                                        <div class="info">
                                            Оплатить бонусам
                                            <span @click="showBonusBill = false; notIsNumber= '';">Отменить</span>
                                        </div>
                                        <div class="sum_wrapper">
                                            <div class="sum minus" @click="minusBonusSum"
                                                 :class="{disabled: disabledMinus}">-
                                            </div>
                                            <input type="tel"
                                                   class="sum value"
                                                   v-model="bonusSum"
                                                   :class="{error: tooBigSum}"
                                                   @blur="blurSum"
                                            >
                                            <span class="ruble_symbol">₽</span>
                                            <div class="sum plus" @click="plusBonusSum"
                                                 :class="{disabled: disabledPlus}">+
                                            </div>
                                        </div>
                                    </div>
                                </transition>
                                <transition name="fade">
                                    <div v-if="tooBigSum" class="error text-center" style="padding: 5px 0;">
                                        Недостаточно средств на бонусном счете
                                    </div>
                                    <div v-if="notIsNumber" class="error text-center" style="padding: 5px 0;">
                                        {{notIsNumber}}
                                    </div>
                                </transition>
                            </div> -->
                        </div>
                        <div v-show="showPaymentOrderButton && !['installment_payment', 'installment_deposit', 'prolongation_deposit', 'AMNESTY_2019', 'credit_rating'].includes($pay.paymentType)"
                             class="columns four pay-order ">
                            <button @click="$modal.show('modal-payment-order')" class="order">
                                <SVGIcon xlink="sort-20" :fill="$theme.colors.blue"/>
                                <span class="link" style="text-transform: none">Порядок оплаты</span>
                            </button>
                        </div>
                        <div class="columns six pay-details" v-if="$pay.paymentType === 'prolongation_deposit'">
                            <span class="link dashed" @click="details">Детализация платежа</span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <modal-payment-order v-if="$pay.paymentType !== 'prolongation_deposit'"/>
        <modal-payment-details
                v-else
                ref="modalPaymentsDetails">
            <div slot="prolongation">

            </div>
        </modal-payment-details>
    </div>
</template>

<script>
    //test
    import ModalPaymentOrder from '@/components/Modals/ModalPaymentOrder';
    import { mapGetters } from 'vuex';
    import modalAdditionalServices from '@/components/Modals/AdditinalServices.vue';
    import modalPaymentDetails from '@/components/Modals/PaymentsDetails.vue';
    import Multiselect from '@/UI/Multiselect';

    import UserGetter from '@/mixins/User/UserGetterMixin';
    import UserSetter from '@/mixins/User/UserSetterMixin';
    import UserErrorText from '@/mixins/User/UserErrorTextMixin';
    import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin';
    import ErrorHandleMixin from '@/mixins/ErrorHandleMixin';
    import ValidateMessage from '@/components/Validators/ValidateMessage';
    import SVGIcon from '@/components/SVGIcon';
    import TextWayPay from '@/components/Pay/TextWayPay'

    export default {
        name: 'SumAndOrder',
        mixins: [
            UserGetter,
            UserSetter,
            UserErrorText,
            GetValidateClass,
            ErrorHandleMixin
        ],
        components: {
            ModalPaymentOrder,
            modalAdditionalServices,
            modalPaymentDetails,
            Multiselect,
            ValidateMessage,
            SVGIcon,
            TextWayPay
        },
        props: {
            installment: {
                type: Boolean,
                default: false
            },
            card: {
                required: false,
                default: false,
            },
            text: {
              default: ''
            }
        },
        data() {
            return {
                sum: null,
                type: null,
                mask: '',
                showBonusBill: false,
                bonusSum: 0,
				notIsNumber: ''
            };
        },
        computed: {
            orderNumber() {
                //допник всегда идет первым номером.
                return this.$pay.paymentOrder[0].orderNumber;
            },

            sumToPay: {
                get() {
                    if (this.getPaymentAmount) {
                        return this.getPaymentAmount;
                    }

                    if (this.$pay.paymentType === 'installment_payment') {
                        this.sum = this.getPaymentAmount;
                        return this.getPaymentAmount;
                    }

                    if (!this.$pdl.supplementary.prolongation) {
                        this.sum = this.$payment.totalDebt;
                        return this.$payment.totalDebt;
                    }
                },
                set(newSum) {
                    console.log('newSum', newSum)
                    if (newSum === null) {
                        return;
                    }
                    this.sum = String(newSum)
                        .replace(/[^\d\.]/g, '');
                    this.$emit('input', this.sum);
                }
            },
            ...mapGetters(['showPaymentOrderButton', 'getPaymentAmount', 'getPaymentType']),
            disabledPlus() {
                return this.bonusSum === this.$pay.bonusBalance;
            },
            disabledMinus() {
                return this.bonusSum <= 1;
            },
            tooBigSum () {
                return this.bonusSum > this.$pay.bonusBalance
            }
        },
        watch: {
            '$store.getters.getPaymentOrder'() {
                this.$emit('input', this.getPaymentAmount);
            },
            showBonusBill (state) {
                if(!state) {
                    this.bonusSum = 0;
                }
            },
            bonusSum (sum) {
                if (sum) {
                    this.$store.commit('PAYMENT_ADD_BONUS_SUM', sum);
                } else {
                    this.$store.commit('PAYMENT_CLEAR_BONUS_SUM');
                }
            },
        },

        created() {
            if (this.getPaymentAmount) {
                // сразу заменим сумму
                this.$emit('input', this.getPaymentAmount);
            }

            this.$store.dispatch('PAYMENT_GET_BONUS_BALANCE');
        },

        methods: {
            minusBonusSum() {
                const sum = Math.ceil(this.bonusSum - 100);
                this.bonusSum = sum > 0 ? sum : 0;
            },
            plusBonusSum() {
                const sum = Math.ceil(this.bonusSum + 100);
                this.bonusSum = sum <= this.$pay.bonusBalance ? sum : this.$pay.bonusBalance;
            },
			blurSum () {
				let bonus = this.convertToNumber(this.bonusSum);
				if (bonus > this.getPaymentAmount) {
					if (this.$pay.bonusBalance >= this.getPaymentAmount) {
						this.bonusSum = Math.ceil(this.getPaymentAmount);
					} else {
						this.bonusSum = Math.floor(this.$pay.bonusBalance);
					}

                } else if (bonus <= this.getPaymentAmount) {
                    if (bonus >= this.$pay.bonusBalance) {
                        this.bonusSum = Math.floor(this.$pay.bonusBalance);
                    } else {
                        this.bonusSum = Math.floor(bonus);
                    }
                } else if (!Number.isInteger(bonus)) {
					this.bonusSum = Math.ceil(bonus)
                }
            },
            convertToNumber (num) {
				if (/^[0-9./-]+$/.test(num)){
					this.notIsNumber = false;
					if (/-/.test(num)) {
						this.bonusSum = 0;
						this.notIsNumber = 'Сумма не может быть отрицательной';
						return 0;
					} else {
						return Number(num);
					}

				} else {
					this.notIsNumber = 'В поле может быть указана только сумма';
					this.bonusSum = 0;
                    return 0
				}
            },
            /**
             * Расскрыть детали платежа, если оплачиваем пролонгацию
             */
            details() {
                this.$modal.show('payment-details');
                if (!this.$refs.modalPaymentsDetails._events.answer) {
                    this.$refs.modalPaymentsDetails.$on('answer', (answer) => {
                        this.$modal.hide('payment-details');
                        this.setPaymentAmount(answer);
                    });
                }
            },

            /**
             * Смена суммы платежа, если оплачиваем пролонгацию и выбрали "детали платежа".
             * @param {pos: boolean, dop: boolean} data
             */
            setPaymentAmount(data) {
                console.log('setPaymentAmount', data);
                let total = 0;
                if (data.dop) {
                    total += parseFloat(this.$prolongation.percentsSum);
                }

                if (data.pos && this.$posServices) {
                    total += parseFloat(this.$posServices.sumTotal);
                }
                this.$store.commit('SET_PAYMENT_DATA', data);
                this.$store.commit('SET_PAYMENT', {
                    type: 'prolongation_deposit',
                    amount: total
                });


                this.sumToPay = total;
            }
        },
    };
</script>

<style scoped lang="scss">
    @import "static/css/variables/media.scss";
    @import "static/css/variables/color.scss";

    .pay-sum {
        @media #{$mobile} {
            padding-right: 0 !important;
        }
        & span.ruble {
            right: 55px;
            top: 40px;
            font-size: 19px;
            @media #{$mobile} {
                right: 10px;
            }
        }

        & > input {
            margin-bottom: 20px !important;
        }
    }

    .bonus_wrapper {
        margin-bottom: 40px;
        & .bonus_rouble {
            text-transform: uppercase;
            border: 1px solid #b7c6d0;
            padding: 13px 0;
            width: 100%;
            font-size: 11px;
            text-align: center;
            border-radius: 5px;
            margin-bottom: 40px;
            cursor: pointer;
        }

        & .calculate {
            display: flex;
            flex-wrap: wrap;
            align-items: center;
            justify-content: center;

            & .info {
                padding: 13px 0;
                @media #{$mobile} {
                    text-align: center;
                }
                line-height: 1.82;
                letter-spacing: 1px;
                color: #323c47;
                font-size: 11px;
                text-transform: uppercase;
                flex-grow: 1;

                & > span {
                    color: #4d92e3;
                    cursor: pointer;
                    margin-left: 10px;
                }
            }

            & .sum_wrapper {
                display: flex;
                position: relative;
                @media #{$mobile} {
                    margin-top: 20px;
                }

                & .sum.plus, & .sum.minus {
                    user-select: none;
                    width: 20px;
                    height: 20px;
                    background: #4d92e3;
                    border-radius: 5px;
                    color: #fff;
                    padding: 0;
                    line-height: 20px;
                    text-align: center;
                    display: block;
                    cursor: pointer;

                    &.disabled {
                        background: #e9eff4;
                    }

                }

                & .sum.value {

                    width: 80px;
                    border: none;
                    border-bottom: 1px dotted #e9eff4;
                    background: #fff;
                    font-size: 15px;
                    font-weight: bold;
                    height: 25px;
                    margin: 0 7px;
                    @media #{$mobile} {
                        margin: 0 15px;
                        height: 30px;
                        line-height: 30px;
                    }
                    text-align: center;
                    padding-right: 20px;
                    padding-left: 6px;
                }

                & .ruble_symbol {
                    position: absolute;
                    right: 30px;
                    font-weight: 500;
                    font-size: 15px;

                }
            }
        }

    }

    .pay-order {
       & > button.order {
           position: relative;
           display: flex !important;
           align-items: center;

           @media #{$mobile} {
               top: -10px !important;
               position: relative;
           }

           & > svg {
               margin-right: 20px;
           }
       }
    }

    .pay-order, .pay-details {
        margin-top: 40px;
    }

    @media #{$mobile} {
        .white-block {
            & .padding {
                padding: 30px 10px 0;
                & button {
                    padding: 0 7px;
                }
            }
        }
        .pay-order, .pay-details {
            margin-top: 0px;
        }
        .pay-order {
            margin-left: -10px;
        }
    }

    .flx {
        align-items: center;
        display: flex;
    }

    .methods-pay-sum::-webkit-input-placeholder { /* Chrome/Opera/Safari */
        font-size: 14px;
        /*color: #80808000;*/
    }

    .methods-pay-sum::-moz-placeholder { /* Firefox 19+ */
        font-size: 14px;
        /*color: #80808000;*/
    }

    .methods-pay-sum:-ms-input-placeholder { /* IE 10+ */
        font-size: 14px;
        /*color: #80808000;*/
    }

    .methods-pay-sum:-moz-placeholder { /* Firefox 18- */
        font-size: 14px;
        /*color: #80808000;*/
    }

    .order {
        padding: 11px 20px !important;
        line-height: 0 !important;
        height: auto !important;
        border: none !important;
        font-weight: normal !important;
    }

    .row.pay-sum-order .white-block {
        border-bottom-left-radius: 0px;
        border-bottom-right-radius: 0px;
    }


</style>
